TAR_OPTS="-b8"
+# List of default archive extensions to try
+MY_ARCH_EXT="tar.bz2 tar.gz tgz tar.Z zip"
+
HV_FONTS_PATH="/usr/share/fonts"
DEFAULT_EDITOR=nano
+DEFAULT_IPKG_SCRIPT="ipkg.def"
+
+source ./stage.def
+
# It seems that when compiling bash-4.0, using
# "make -j 1" is causing problems...
if [ "x${MAKEJOBS}" = "x1" ]; then
export CLFS_BUILDFLAGS CLFS_TARGET CLFS_ARCH CLFS_HOST CLFS_ENDIAN CLFS_NOT_ENDIAN
+if [ -z "${LFS_STAGE}" ]; then
+ echo "LFS_STAGE is undefined (see stage.def)"
+ return ${EXIT_FAILURE}
+fi
+
+if [ "x${LFS_STAGE}" != "xstage0" -a "x${LFS_STAGE}" != "xstage1" ] ;then
+ LFS=""
+fi
+
CLFS=${LFS}
-function function_exists
+# Create log directory and log file for current stage if necessary
+# This should be done automatically...
+init_log_file()
{
- local FUNCTION_NAME=$1
-
- [ -z "$FUNCTION_NAME" ] && return 1
+ # Scripts directory
+ export SCRDIR=$(pwd)
- declare -F "$FUNCTION_NAME" > /dev/null 2>&1
+ export LFS_PKG_DIR="$(dirname $(pwd))/packages/${LFS_STAGE}"
+ export LFS_LOG_DIR=${LFS}/var/log/hvlinux-install/${LFS_STAGE}
+ export LFS_LOG_FILE=${LFS_LOG_DIR}/install.log
+ export LFS_TMP="${LFS}/tmp"
- return $?
+ mkdir -p ${LFS_LOG_DIR} &&
+ if [ ! -f ${LFS_LOG_FILE} ]; then
+ touch ${LFS_LOG_FILE} || exit 1
+ fi
}
# Extracting the version number from a complete package name.
return ${EXIT_SUCCESS}
}
-# Create log directory and log file for current stage if necessary
-# This should be done automatically...
-init_log_file()
-{
- mkdir -p ${LFS_LOG_DIR} &&
- if [ ! -f ${LFS_LOG_FILE} ]; then
- touch ${LFS_LOG_FILE} || exit 1
- fi
-}
-
# Create symbolic links for start/stop scripts in /etc/rc.d
#
# Arg #1: script name
fi
# Making sure bootscript has correct permissions
- chmod -v 740 ${LFS}/etc/rc.d/init.d/${SCRIPTNAME} &&
+ chmod -v 740 ${LFS}/etc/rc.d/init.d/${SCRIPTNAME}
# Removing any old links
for level in sysinit 0 1 2 3 4 5 6; do
- cd ${LFS}/etc/rc.d/rc${level}.d &&
- rm -v -f $(find . -name "???${SCRIPTNAME}") || exit 1
- done &&
+ cd ${LFS}/etc/rc.d/rc${level}.d
+ rm -v -f $(find . -name "???${SCRIPTNAME}")
+ done
if [ ${START} -ne 0 ]; then
# Creating new start links
for level in ${START_LEVELS}; do
- cd ${LFS}/etc/rc.d/rc${level}.d &&
- ln -v -s ../init.d/${SCRIPTNAME} S${START}${SCRIPTNAME} || exit 1
+ cd ${LFS}/etc/rc.d/rc${level}.d
+ ln -v -s ../init.d/${SCRIPTNAME} S${START}${SCRIPTNAME}
done
- fi &&
+ fi
if [ ${STOP} -ne 0 ]; then
# Creating new stop links
for level in ${STOP_LEVELS}; do
- cd ${LFS}/etc/rc.d/rc${level}.d &&
- ln -v -s ../init.d/${SCRIPTNAME} K${STOP}${SCRIPTNAME} || exit 1
+ cd ${LFS}/etc/rc.d/rc${level}.d
+ ln -v -s ../init.d/${SCRIPTNAME} K${STOP}${SCRIPTNAME}
done
fi
}
local STOP=${4}
# Making sure bootscript has correct permissions
- chmod 740 ${LFS}/etc/rc.d/init.d/${SCRIPTNAME} &&
+ chmod 740 ${LFS}/etc/rc.d/init.d/${SCRIPTNAME}
# Removing any old links
- cd ${LFS}/etc/rc.d/rc${RCLEVEL}.d &&
- rm -v -f $(find . -name "???${SCRIPTNAME}") &&
+ cd ${LFS}/etc/rc.d/rc${RCLEVEL}.d
+ rm -v -f $(find . -name "???${SCRIPTNAME}")
if [ ${START} -ne 0 ]; then
# Creating new start link
- cd ${LFS}/etc/rc.d/rc${RCLEVEL}.d &&
- ln -v -s ../init.d/${SCRIPTNAME} S${START}${SCRIPTNAME} || exit 1
- fi &&
+ cd ${LFS}/etc/rc.d/rc${RCLEVEL}.d
+ ln -v -s ../init.d/${SCRIPTNAME} S${START}${SCRIPTNAME}
+ fi
if [ ${STOP} -ne 0 ]; then
# Creating new stop link
- cd ${LFS}/etc/rc.d/rc${RCLEVEL}.d &&
- ln -v -s ../init.d/${SCRIPTNAME} K${STOP}${SCRIPTNAME} || exit 1
+ cd ${LFS}/etc/rc.d/rc${RCLEVEL}.d
+ ln -v -s ../init.d/${SCRIPTNAME} K${STOP}${SCRIPTNAME}
fi
}
# PATH=... matches but not MANPATH=...
if grep "^${VARIABLE}=\"" ${FILE} 1> /dev/null 2>&1; then
# Variable value is enclosed by double-quotes
- sed -i "s!\(^${VARIABLE}=\".*\)\(\"\)!\1${SEP}${VALUE}\"!" ${FILE} || exit 1
+ sed -i "s!\(^${VARIABLE}=\".*\)\(\"\)!\1${SEP}${VALUE}\"!" ${FILE}
else
# Variable value is NOT enclosed by double-quotes
- sed -i "s!\(^${VARIABLE}=.*\)!\1${SEP}${VALUE}!" ${FILE} || exit 1
+ sed -i "s!\(^${VARIABLE}=.*\)!\1${SEP}${VALUE}!" ${FILE}
fi
# Adding new value to variable (case with export before)
exit ${EXIT_FAILURE}
fi
}
-
-# Evaluates the return value of the process that was run just before this
-# function was called.
-eval_retval()
-{
- if [ $? -ne 0 ]; then
- print_status failure
- exit ${EXIT_FAILURE}
- fi
-}
-
-# Obtain the name of the base directory for the decompressed package.
-# First argument: package name
-static_decompressed_dirname()
-{
- local PACKAGE=${1}
-
- # List of default archive extensions to try
- local MY_ARCH_EXT="tar.bz2 tar.gz tgz tar.Z zip"
-
- for arch_ext in ${MY_ARCH_EXT}; do
- if [ ! -f ${LFS_PKG_DIR}/${PACKAGE}.${arch_ext} ]; then
- # Try next archive extension.
- continue;
- fi
-
- case ${arch_ext} in
- tar.bz2|tar.gz|tgz|tar.Z)
- # Remove optional "./" leading component with sed
- # and extract base directory name with awk.
- # tar 1.23 reports an error when using pipes, so
- # remove error message with "2> /dev/null"
- local DIRNAME=$(tar ${TAR_OPTS} -tf ${LFS_PKG_DIR}/${PACKAGE}.tar.bz2 2> /dev/null | head -n1 | sed 's!^\./!!' | awk -F \/ '{print $1}')
- echo ${DIRNAME}
- ;;
- zip)
- # TODO
- echo ${PACKAGE}
- ;;
- esac
-
- return $?
- done
-
- # Failure or file not found
- echo "${FUNCNAME}(): Missing source package for \"${PACKAGE}\"" > /dev/stderr
- return ${EXIT_FAILURE}
-}
# Applying patch
# First argument is the name of the patch
if ls ${LFS_PKG_DIR}/${1}-*.patch 1> /dev/null 2>&1; then
cd ${LFS_PKG_DIR}
for patch in ${1}-*.patch; do
- apply_patch ${patch} ${TARGET_DIR} || exit 1
+ apply_patch ${patch} ${TARGET_DIR}
done
fi
return $?
}
+# Obtain the name of the base directory for the decompressed package.
+# First argument: package name
+static_decompressed_dirname()
+{
+ local PACKAGE=${1}
+
+ for arch_ext in ${MY_ARCH_EXT}; do
+ if [ ! -f ${LFS_PKG_DIR}/${PACKAGE}.${arch_ext} ]; then
+ # Try next archive extension.
+ continue;
+ fi
+
+ case ${arch_ext} in
+ tar.bz2|tar.gz|tgz|tar.Z)
+ # Remove optional "./" leading component with sed
+ # and extract base directory name with awk.
+ # tar 1.23 reports an error when using pipes, so
+ # remove error message with "2> /dev/null"
+ local DIRNAME=$(tar ${TAR_OPTS} -tf ${LFS_PKG_DIR}/${PACKAGE}.tar.bz2 2> /dev/null | head -n1 | sed 's!^\./!!' | awk -F \/ '{print $1}')
+ echo ${DIRNAME}
+ ;;
+ zip)
+ # TODO
+ echo ${PACKAGE}
+ ;;
+ esac
+
+ return $?
+ done
+
+ # Failure or file not found
+ echo "${FUNCNAME}(): Missing source package for \"${PACKAGE}\"" > /dev/stderr
+ return ${EXIT_FAILURE}
+}
+
# Decompression of a package
# First argument: package name
# Second argument: directory where decompressing (optional)
local PACKAGE=${1}
- # List of default archive extensions to try
- local MY_ARCH_EXT="tar.bz2 tar.gz tgz tar.Z zip"
-
for arch_ext in ${MY_ARCH_EXT}; do
if [ ! -f ${LFS_PKG_DIR}/${PACKAGE}.${arch_ext} ]; then
# Try next archive extension.
if [ -d ${TOPDIR}/${PACKAGE} ]; then
# Removing old source directory (if any)
- rm -v -rf ${TOPDIR}/${PACKAGE} || exit 1
+ rm -rf ${TOPDIR}/${PACKAGE}
fi
- cd ${TOPDIR}
-
# Decompressing package
case ${arch_ext} in
tar.bz2)
- tar ${TAR_OPTS} -jxvf ${LFS_PKG_DIR}/${PACKAGE}.${arch_ext} || return 1
+ tar -C ${TOPDIR} ${TAR_OPTS} -jxf \
+ ${LFS_PKG_DIR}/${PACKAGE}.${arch_ext}
;;
tar.gz|tgz|tar.Z)
- tar ${TAR_OPTS} -zxvf ${LFS_PKG_DIR}/${PACKAGE}.${arch_ext} || return 1
+ tar -C ${TOPDIR} ${TAR_OPTS} -zxf \
+ ${LFS_PKG_DIR}/${PACKAGE}.${arch_ext}
;;
zip)
- echo ZIPZIPZIP
- unzip ${LFS_PKG_DIR}/${PACKAGE}.${arch_ext} || return 1
+ unzip -qq -d ${TOPDIR} ${LFS_PKG_DIR}/${PACKAGE}.${arch_ext}
;;
esac
- cd - 1> /dev/null 2>&1
-
return $?
done
return ${EXIT_FAILURE}
}
+hvtrap_setup()
+{
+ # Setting ERR trap does implicit `set -o errexit'.
+ trap hvtrap_err ERR
+ trap hvtrap_int INT
+}
+
+hvtrap_err()
+{
+ echo
+ echo "*** An error occured during ${LFS_STAGE}"
+ exit 1
+}
+
+hvtrap_int()
+{
+ echo
+ echo "*** Installation interrupted during ${LFS_STAGE}"
+ exit 1
+}
+
+ipkg_trap_setup()
+{
+ exec 6>&1 # Save current "value" of stdout.
+ trap ipkg_trap_handler INT TERM EXIT ERR
+}
+
+ipkg_trap_end()
+{
+ trap - INT TERM EXIT ERR
+
+ # Restore global trap
+ hvtrap_setup
+}
+
+ipkg_trap_handler()
+{
+ exec 1>&6 6>&- # Restore stdout and close file descriptor #6.
+ print_status failure
+
+ ipkg_trap_end
+ exit 1
+}
+
# Installation of a package
# Arg. #1: Package name and version (ex: gcc-4.5.1)
# Remaining arguments: Additional configure options
# gnome
# xorg
# pm
-# -s Name of script to execute (default is ipkg.sh)
+# -s Name of script to execute or name of definition file (default is
+# to source ipkg.def)
ipkg()
{
START_TIME=$(echo `date +%s`)
export IPKG_MODE="ac"
export HVLABEL="" # Global variable
- local SCRIPT=./ipkg.sh
+ local SCRIPT=${DEFAULT_IPKG_SCRIPT}
while getopts "hl:m:" flag ;do
case ${flag} in
s)
# Alternate script name
SCRIPT=${OPTARG}
+
+ # Checking if script is valid and executable
+ if [ ! -x ${SCRIPT} ]; then
+ echo "${FUNCNAME}(): cannot execute script: ${SCRIPT}"
+ exit ${EXIT_FAILURE}
+ fi
;;
?)
echo "${FUNCNAME}(): Invalid option: ${OPTARG}."
unset OPTIND
unset OPTARG
- local PACKAGE_NAME=${1}
+ export PACKAGE=${1}
# Checking for correct number of arguments
if [ $# -lt 1 ]; then
fi
shift
- local CONFIGURE_OPTS=${*}
+ export CONFIGURE_OPTS=${*}
if [ -z "${HVLABEL}" ]; then
# Default label = package name and version
- HVLABEL=${PACKAGE_NAME}
- fi
-
- # Checking if script is valid and executable
- if [ ! -x ${SCRIPT} ]; then
- echo
- echo "${FUNCNAME}(): cannot execute script: ${SCRIPT}"
- exit ${EXIT_FAILURE}
+ HVLABEL=${PACKAGE}
fi
PACKAGE_LOG=${LFS_LOG_DIR}/${HVLABEL}.log
MSGSTRING="Installing ${HVLABEL}"
display_checkbox_msg ${MSGSTRING}
+ ipkg_trap_setup
+
echo "------------------------" 1>> ${LFS_LOG_FILE}
echo "${MSGSTRING}" 1>> ${LFS_LOG_FILE}
- echo "Decompressing package" 1>> ${PACKAGE_LOG} 2>&1 &&
- decompress_package ${PACKAGE_NAME} 1> /dev/null 2>> ${PACKAGE_LOG}
- eval_retval
-
- local DECOMPRESSED_DIRNAME=$(static_decompressed_dirname ${PACKAGE_NAME})
+ # All output from commands in this block sent to file $PACKAGE_LOG.
+ exec > ${PACKAGE_LOG} 2>&1
- # Rename the decompressed package as per the package name if necessary
- if [ "x${DECOMPRESSED_DIRNAME}" != "x${PACKAGE_NAME}" ]; then
- mv ${LFS_TMP}/${DECOMPRESSED_DIRNAME} ${LFS_TMP}/${PACKAGE_NAME}
- eval_retval
+ if [ "x${SCRIPT}" = "x${DEFAULT_IPKG_SCRIPT}" ]; then
+ # Executing standard ac script.
+ source ${SCRDIR}/../functions-ac
+ source ${SCRDIR}/${DEFAULT_IPKG_SCRIPT}
+ ipkg_script
+ else
+ # Executing custom script.
+ ${SCRIPT} ${PACKAGE} ${CONFIGURE_OPTS}
fi
- # Displaying package source size in log file
- echo " Source size:" $(du -h -s ${LFS_TMP}/${PACKAGE_NAME} | awk '{ print $1 }') 1>> ${LFS_LOG_FILE}
+ # Make sure we are at a known location
+ cd ${SCRDIR}
- # Removing old build directory (if any)
- if [ -d ${LFS_TMP}/${PACKAGE_NAME}-build ]; then
- echo "Removing old build directory" 1>> ${PACKAGE_LOG} 2>&1 &&
- rm -v -rf ${LFS_TMP}/${PACKAGE_NAME}-build 1> /dev/null 2>> ${PACKAGE_LOG}
- eval_retval
- fi
-
- # Creating build directory
- mkdir -v ${LFS_TMP}/${PACKAGE_NAME}-build 1>> ${PACKAGE_LOG} 2>&1
- eval_retval
-
- # Executing script.
- ${SCRIPT} ${PACKAGE_NAME} ${CONFIGURE_OPTS} 1>> ${PACKAGE_LOG} 2>&1
- eval_retval
-
- # Displaying package build size in log file
- BUILD_SIZE=$(du -h -s -c ${LFS_TMP}/${PACKAGE_NAME} ${LFS_TMP}/${PACKAGE_NAME}-build | grep total | awk '{ print $1 }')
- echo " Build size : ${BUILD_SIZE}" 1>> ${LFS_LOG_FILE}
-
- # Some scripts need to preserve the source or build directory. They can
- # do so by renaming them.
- if [ -d ${LFS_TMP}/${PACKAGE_NAME} ]; then
- # Removing source directory
- echo "Removing source directory" 1>> ${PACKAGE_LOG} 2>&1 &&
- rm -v -rf ${LFS_TMP}/${PACKAGE_NAME} 1> /dev/null 2>> ${PACKAGE_LOG}
- eval_retval
- fi
- if [ -d ${LFS_TMP}/${PACKAGE_NAME}-build ]; then
- # Removing build directory
- echo "Removing build directory" 1>> ${PACKAGE_LOG} 2>&1 &&
- rm -v -rf ${LFS_TMP}/${PACKAGE_NAME}-build 1> /dev/null 2>> ${PACKAGE_LOG}
- eval_retval
- fi
+ exec 1>&6 # Restore stdout.
# Writing success string to the end of the log file
echo "${HVLABEL} successfully installed" 1>> ${LFS_LOG_FILE}
# Displaying build time after the package name
print_status success
- return $EXIT_SUCCESS
-}
-
-# Run command, no log
-# First argument: Message to display during script
-# Second argument: command + arguments
-rcmd()
-{
- START_TIME=$(echo `date +%s`)
-
- # Checking for correct number of arguments
- if [ $# -lt 2 ]; then
- echo "${FUNCNAME}(): Missing argument(s)"
- exit ${EXIT_FAILURE}
- fi
-
- local MSGSTRING=${1}
- local CMD=${2}
- shift
- local CMD_WITH_ARGS=${*}
-
- display_checkbox_msg ${MSGSTRING}
- echo ${CMD_WITH_ARGS} 1>> ${LFS_LOG_FILE}
-
- # Executing command
- ${CMD_WITH_ARGS} 1>> ${LFS_LOG_FILE} 2>&1
- if [ $? -ne 0 ]; then
- print_status failure
- if [ -n "${RCMD_NO_EXIT}" ]; then
- return ${EXIT_FAILURE}
- else
- exit ${EXIT_FAILURE}
- fi
- fi
-
- # Displaying build time after the package name
- print_status success
+ ipkg_trap_end
return $EXIT_SUCCESS
}
shift
SCRIPT_ARGS=${*}
+ # Make sure we are at a known location
+ cd ${SCRDIR}
+
# Checking script mode:
if [ "x${SCRMODE}" != "xonce" -a "x${SCRMODE}" != "xmult" ]; then
echo "${FUNCNAME}(): First argument invalid, must be \"once\" or \"mult\" (\"${SCRMODE}\" given)"
fi
# Checking if script is valid and executable
- if [ ! -x ./${SCRIPT} ]; then
+ if [ ! -x ${SCRDIR}/${SCRIPT} ]; then
echo "${FUNCNAME}(): script not found: ${SCRIPT}"
exit ${EXIT_FAILURE}
fi
fi
display_checkbox_msg ${MSGSTRING}
+
+ ipkg_trap_setup
+
echo "------------------------" 1>> ${LFS_LOG_FILE}
echo ${HVLABEL} 1>> ${LFS_LOG_FILE}
# Executing script
- ./${SCRIPT} ${SCRIPT_ARGS} 1>> ${PACKAGE_LOG} 2>&1
- eval_retval
+ ${SCRDIR}/${SCRIPT} ${SCRIPT_ARGS} 1>> ${PACKAGE_LOG} 2>&1
if [ "x${SCRMODE}" = "xonce" ]; then
# Writing success string to the end of the log file
# Displaying build time after the package name
print_status success
+ ipkg_trap_end
+
+ return $EXIT_SUCCESS
+}
+
+# Run command, no log
+# First argument: Message to display during script
+# Second argument: command + arguments
+rcmd()
+{
+ START_TIME=$(echo `date +%s`)
+
+ # Checking for correct number of arguments
+ if [ $# -lt 2 ]; then
+ echo "${FUNCNAME}(): Missing argument(s)"
+ exit ${EXIT_FAILURE}
+ fi
+
+ local MSGSTRING=${1}
+ local CMD=${2}
+ shift
+ local CMD_WITH_ARGS=${*}
+
+ display_checkbox_msg ${MSGSTRING}
+
+ echo ${CMD_WITH_ARGS} 1>> ${LFS_LOG_FILE}
+
+ # Executing command
+ ${CMD_WITH_ARGS} 1>> ${LFS_LOG_FILE} 2>&1
+ if [ $? -ne 0 ]; then
+ print_status failure
+ if [ -n "${RCMD_NO_EXIT}" ]; then
+ return ${EXIT_FAILURE}
+ else
+ exit ${EXIT_FAILURE}
+ fi
+ fi
+
+ # Displaying build time after the package name
+ print_status success
+
return $EXIT_SUCCESS
}
# Reposition cursor at start of line
echo -en "${SET_CURSOR_START_LINE}"
+ # Display colored 'X'
echo -en "${BRACKET}[${COLOR}X${BRACKET}]${NORMAL} ${MSGSTRING}"
if [ "x${MSGSTRING}" != "x" ]; then
--- /dev/null
+#!/bin/bash
+
+function_exists()
+{
+ local FUNCTION_NAME=$1
+
+ [ -z "$FUNCTION_NAME" ] && return 1
+
+ declare -F "$FUNCTION_NAME" > /dev/null 2>&1
+
+ return $?
+}
+
+unset -f hvconfig_cache
+unset -f hvconfig_pre
+unset -f hvconfig_post
+unset -f hvbuild_post
+
+ipkg_decompress_package()
+{
+ echo "Decompressing package"
+ decompress_package ${PACKAGE}
+
+ local DECOMPRESSED_DIRNAME=$(static_decompressed_dirname ${PACKAGE})
+
+ # Rename the decompressed package as per the package name if necessary
+ if [ "x${DECOMPRESSED_DIRNAME}" != "x${PACKAGE}" ]; then
+ mv -v ${LFS_TMP}/${DECOMPRESSED_DIRNAME} ${LFS_TMP}/${PACKAGE}
+ fi
+
+ # Displaying package source size in log file
+ echo " Source size:" $(du -h -s ${LFS_TMP}/${PACKAGE} | awk '{ print $1 }') 1>> ${LFS_LOG_FILE}
+
+ # Removing old build directory (if any)
+ if [ -d ${LFS_TMP}/${PACKAGE}-build ]; then
+ echo "Removing old build directory"
+ rm -rf ${LFS_TMP}/${PACKAGE}-build
+ fi
+
+ # Creating build directory
+ mkdir -v ${LFS_TMP}/${PACKAGE}-build
+}
+
+# Default configure function
+hvconfig()
+{
+ echo "Running configure with options:"
+ echo " <${CONFIGURE_OPTS}>"
+
+ if [ "x${IPKG_MODE}" = "xacnb" ]; then
+ # Broken autoconf package that must build in source dir
+ cd ${LFS_TMP}/${PACKAGE}
+ else
+ # Standard autoconf mode
+ cd ${LFS_TMP}/${PACKAGE}-build
+ fi
+
+ ${LFS_TMP}/${PACKAGE}/configure ${CONFIGURE_OPTS}
+}
+
+# Default build function
+hvbuild()
+{
+ if [ "x${IPKG_MODE}" = "xnoac" ]; then
+ cd ${LFS_TMP}/${PACKAGE}
+ fi
+
+ ${HVMAKE}
+ ${HVMAKE} install
+}
+
+# Default patch applying function
+hvpatch()
+{
+ # Applying patches (if any)
+ apply_patches ${PACKAGE}
+}
+
+ipkg_finish()
+{
+ # Make sure to return to scripts directory
+ cd ${SCRDIR}
+
+ # Displaying package build size in log file
+ BUILD_SIZE=$(du -h -s -c ${LFS_TMP}/${PACKAGE} ${LFS_TMP}/${PACKAGE}-build | grep total | awk '{ print $1 }')
+ echo " Build size : ${BUILD_SIZE}" 1>> ${LFS_LOG_FILE}
+
+ # Some scripts need to preserve the source or build directory. They can
+ # do so by renaming them.
+ if [ -d ${LFS_TMP}/${PACKAGE} ]; then
+ # Removing source directory
+ echo "Removing source directory"
+ rm -rf ${LFS_TMP}/${PACKAGE}
+ fi
+ if [ -d ${LFS_TMP}/${PACKAGE}-build ]; then
+ # Removing build directory
+ echo "Removing build directory"
+ rm -rf ${LFS_TMP}/${PACKAGE}-build
+ fi
+}
+
+# This is the main function doing all the work
+ipkg_script()
+{
+ ipkg_decompress_package
+
+ PACKAGE_DEF=${SCRDIR}/pkg/$(get_pkg_name ${PACKAGE})
+
+ if [ -f ${PACKAGE_DEF} ]; then
+ echo "Load custom package functions and definitions"
+ source ${PACKAGE_DEF}
+ fi
+
+ hvpatch
+
+ # Execute config-cache function if applicable
+ if function_exists hvconfig_cache ; then
+ echo "Running configure cache script"
+ hvconfig_cache
+
+ CONFIGURE_OPTS="${CONFIGURE_OPTS} --cache-file=${LFS_TMP}/${PACKAGE}-build/config.cache"
+ fi
+
+ # Execute pre-configure function if applicable
+ if function_exists hvconfig_pre ; then
+ echo "Running configure pre-script"
+ hvconfig_pre
+ fi
+
+ if [ "x${IPKG_MODE}" = "xnoac" ]; then
+ echo "Not calling configure because ${PACKAGE} has no configure script"
+ else
+ hvconfig
+ fi
+
+ # Execute post-configure function if applicable
+ if function_exists hvconfig_post ; then
+ echo "Running configure post-script"
+ hvconfig_post
+ fi
+
+ hvbuild
+
+ # Execute post-build function if applicable
+ if function_exists hvbuild_post ; then
+ echo "Running build post-script"
+ hvbuild_post
+ fi
+}